#!/usr/bin/env python

# Copyright 2010 Anthony Towns <aj@erisian.com.au>
# GPLv2+

from xml.dom import minidom
import pipes

mf = minidom.parse(open("mailFilters.xml"))

def goog2notmuch(term, value):
    if term == "list":
	if value[0]+value[-1] in ['()', '""']:
	    value = value[1:-1]
        return "to:" + value
    return "tag:omg-i-got-confused"

for e in mf.childNodes[0].getElementsByTagName("entry"):
    addtags = []
    deltags = []
    search = []
    for a in e.getElementsByTagName("apps:property"):
        n,v = a.getAttribute("name"), a.getAttribute("value")
        if n == "label":
            addtags.append(v)
        elif n == "shouldArchive" and v == "true":
            deltags.append("inbox")
        elif n == "shouldTrash" and v == "true":
            addtags.append("deleted")
        elif n == "shouldMarkAsRead" and v == "true":
            deltags.append("unread")
        elif n == "from":
            search.append("from:%s" % v)
        elif n == "subject":
            search.append("subject:%s" % v)
        elif n == "doesNotHaveTheWord" and ':' in v:
            search.append("not")
	    search.append(goog2notmuch(*v.split(':',1)))
        elif n == "hasTheWord" and ':' in v:
	    search.append(goog2notmuch(*v.split(':',1)))
        elif n == "hasTheWord":
            search.append(v)
        elif n == "doesNotHaveTheWord":
            search.append("not")
            search.append(v)
        else:
            print "XXX %s : %s" % (n,v)
    tags = ["-"+x for x in deltags] + ["+"+x for x in addtags]
    if tags == []:
	print "WTF?? NO TAGS"
	continue
    tagsearch = sum([ ["not", "tag:"+x, "or"] for x in addtags ], [])
    tagsearch += sum([ ["tag:"+x, "or"] for x in deltags ], [])
    tagsearch = tagsearch[:-1]
    if len(tags) > 1:
        tagsearch = ["("] + tagsearch + [")"]
    search += tagsearch
    print "notmuch tag %s -- %s" % (
	" ".join(pipes.quote(x) for x in tags),
	" ".join(pipes.quote(x) for x in search))

